diff -Nru libica-3.9.0/src/ica_api.c libica-4.0.0/src/ica_api.c
--- libica-3.9.0/src/ica_api.c	2021-10-13 16:00:38.000000000 +0200
+++ libica-4.0.0/src/ica_api.c	2021-12-06 12:01:54.000000000 +0100
@@ -394,7 +394,7 @@
 
 unsigned int ica_sha1(unsigned int message_part,
 		      unsigned int input_length,
-		      unsigned char *input_data,
+		      const unsigned char *input_data,
 		      sha_context_t *sha_context,
 		      unsigned char *output_data)
 {
@@ -449,7 +449,7 @@
 
 unsigned int ica_sha224(unsigned int message_part,
 			unsigned int input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			sha256_context_t *sha256_context,
 			unsigned char *output_data)
 {
@@ -496,7 +496,7 @@
 
 unsigned int ica_sha256(unsigned int message_part,
 			unsigned int input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			sha256_context_t *sha256_context,
 			unsigned char *output_data)
 {
@@ -543,7 +543,7 @@
 
 unsigned int ica_sha384(unsigned int message_part,
 			uint64_t input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			sha512_context_t *sha512_context,
 			unsigned char *output_data)
 {
@@ -591,7 +591,7 @@
 
 unsigned int ica_sha512(unsigned int message_part,
 			uint64_t input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			sha512_context_t *sha512_context,
 			unsigned char *output_data)
 {
@@ -639,7 +639,7 @@
 
 unsigned int ica_sha512_224(unsigned int message_part,
 			    uint64_t input_length,
-			    unsigned char *input_data,
+			    const unsigned char *input_data,
 			    sha512_context_t *sha512_context,
 			    unsigned char *output_data)
 {
@@ -687,7 +687,7 @@
 
 unsigned int ica_sha512_256(unsigned int message_part,
 			    uint64_t input_length,
-			    unsigned char *input_data,
+			    const unsigned char *input_data,
 			    sha512_context_t *sha512_context,
 			    unsigned char *output_data)
 {
@@ -735,7 +735,7 @@
 
 unsigned int ica_sha3_224(unsigned int message_part,
 			unsigned int input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			sha3_224_context_t *sha3_224_context,
 			unsigned char *output_data)
 {
@@ -782,7 +782,7 @@
 
 unsigned int ica_sha3_256(unsigned int message_part,
 			unsigned int input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			sha3_256_context_t *sha3_256_context,
 			unsigned char *output_data)
 {
@@ -829,7 +829,7 @@
 
 unsigned int ica_sha3_384(unsigned int message_part,
 			uint64_t input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			sha3_384_context_t *sha3_384_context,
 			unsigned char *output_data)
 {
@@ -877,7 +877,7 @@
 
 unsigned int ica_sha3_512(unsigned int message_part,
 			uint64_t input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			sha3_512_context_t *sha3_512_context,
 			unsigned char *output_data)
 {
@@ -925,7 +925,7 @@
 
 unsigned int ica_shake_128(unsigned int message_part,
 			uint64_t input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			shake_128_context_t *shake_128_context,
 			unsigned char *output_data, unsigned int output_length)
 {
@@ -980,7 +980,7 @@
 
 unsigned int ica_shake_256(unsigned int message_part,
 			uint64_t input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			shake_256_context_t *shake_256_context,
 			unsigned char *output_data, unsigned int output_length)
 {
@@ -1127,7 +1127,7 @@
 }
 
 unsigned int ica_rsa_mod_expo(ica_adapter_handle_t adapter_handle,
-			      unsigned char *input_data,
+			      const unsigned char *input_data,
 			      ica_rsa_key_mod_expo_t *rsa_key,
 			      unsigned char *output_data)
 {
@@ -1147,12 +1147,12 @@
 		return EINVAL;
 
 	/* fill driver structure */
-	rb.inputdata = (char *)input_data;
+	rb.inputdata = (unsigned char *)input_data;
 	rb.inputdatalength = rsa_key->key_length;
-	rb.outputdata = (char *)output_data;
+	rb.outputdata = output_data;
 	rb.outputdatalength = rsa_key->key_length;
-	rb.b_key = (char *)rsa_key->exponent;
-	rb.n_modulus = (char *)rsa_key->modulus;
+	rb.b_key = rsa_key->exponent;
+	rb.n_modulus = rsa_key->modulus;
 
 	hardware = ALGO_SW;
 	if (adapter_handle == DRIVER_NOT_LOADED)
@@ -1171,7 +1171,9 @@
 				rsa_mod_expo_sw(&rb) : ENODEV;
 	}
 	if (rc == 0)
-		stats_increment(ICA_STATS_RSA_ME, hardware, ENCRYPT);
+		stats_increment(ICA_STATS_RSA_ME_512 +
+				rsa_keysize_stats_ofs(rsa_key->key_length),
+				hardware, ENCRYPT);
 
 	OPENSSL_cleanse(&rb, sizeof(rb));
 
@@ -1224,8 +1226,11 @@
 		/* qInv = (1/q) mod p */
 		BN_mod_inverse(bn_invq, bn_q, bn_p, ctx);
 		memset(tmp_buf, 0, rsa_key->key_length/2);
-		BN_bn2bin(bn_invq, tmp_buf);
-
+#if OPENSSL_VERSION_NUMBER < 0x10100000L
+		BN_bn2bin(bn_invq, tmp_buf + rsa_key->key_length/2 - BN_num_bytes(bn_invq));
+#else
+		BN_bn2binpad(bn_invq, tmp_buf, rsa_key->key_length/2);
+#endif
 		memcpy(rsa_key->qInverse + 8, tmp_buf, rsa_key->key_length/2);
 
 		free(tmp_buf);
@@ -1241,7 +1246,7 @@
 }
 
 unsigned int ica_rsa_crt(ica_adapter_handle_t adapter_handle,
-			 unsigned char *input_data,
+			 const unsigned char *input_data,
 			 ica_rsa_key_crt_t *rsa_key,
 			 unsigned char *output_data)
 {
@@ -1261,18 +1266,18 @@
 		return EINVAL;
 
 	/* fill driver structure */
-	rb.inputdata = (char *)input_data;
+	rb.inputdata = (unsigned char *)input_data;
 	rb.inputdatalength = rsa_key->key_length;
-	rb.outputdata = (char *)output_data;
+	rb.outputdata = output_data;
 	rb.outputdatalength = rsa_key->key_length;
 
 	ica_rsa_crt_key_check(rsa_key);
 
-	rb.np_prime = (char *)rsa_key->p;
-	rb.nq_prime = (char *)rsa_key->q;
-	rb.bp_key = (char *)rsa_key->dp;
-	rb.bq_key = (char *)rsa_key->dq;
-	rb.u_mult_inv = (char *)rsa_key->qInverse;
+	rb.np_prime = rsa_key->p;
+	rb.nq_prime = rsa_key->q;
+	rb.bp_key = rsa_key->dp;
+	rb.bq_key = rsa_key->dq;
+	rb.u_mult_inv = rsa_key->qInverse;
 
 	hardware = ALGO_SW;
 	if (adapter_handle == DRIVER_NOT_LOADED)
@@ -1291,7 +1296,9 @@
 				rsa_crt_sw(&rb) : ENODEV;
 	}
 	if (rc == 0)
-		stats_increment(ICA_STATS_RSA_CRT, hardware, ENCRYPT);
+		stats_increment(ICA_STATS_RSA_CRT_512 +
+				rsa_keysize_stats_ofs(rsa_key->key_length),
+				hardware, ENCRYPT);
 
 	OPENSSL_cleanse(&rb, sizeof(rb));
 
@@ -1422,7 +1429,9 @@
 	}
 
 	if (rc == 0)
-		stats_increment(ICA_STATS_ECKGEN, hardware, ENCRYPT);
+		stats_increment(ICA_STATS_ECKGEN_160 +
+				ecc_keysize_stats_ofs(key->nid),
+				hardware, ENCRYPT);
 
 	return rc;
 }
@@ -1483,7 +1492,9 @@
 	}
 
 	if (rc == 0)
-		stats_increment(ICA_STATS_ECDH, hardware, ENCRYPT);
+		stats_increment(ICA_STATS_ECDH_160 +
+				ecc_keysize_stats_ofs(privkey_A->nid),
+				hardware, ENCRYPT);
 
 	return rc;
 }
@@ -1538,7 +1549,9 @@
 	}
 
 	if (rc == 0)
-		stats_increment(ICA_STATS_ECDSA_SIGN, hardware, ENCRYPT);
+		stats_increment(ICA_STATS_ECDSA_SIGN_160 +
+				ecc_keysize_stats_ofs(privkey->nid),
+				hardware, ENCRYPT);
 
 	return rc;
 }
@@ -1595,7 +1608,9 @@
 	}
 
 	if (rc == 0)
-		stats_increment(ICA_STATS_ECDSA_VERIFY, hardware, ENCRYPT);
+		stats_increment(ICA_STATS_ECDSA_VERIFY_160 +
+				ecc_keysize_stats_ofs(pubkey->nid),
+				hardware, ENCRYPT);
 
 	return rc;
 }
@@ -2346,264 +2361,6 @@
  *
  ******************************************************************************/
 
-unsigned int ica_des_encrypt(unsigned int mode,
-			     unsigned int data_length,
-			     unsigned char *input_data,
-			     ica_des_vector_t *iv,
-			     ica_des_key_single_t *des_key,
-			     unsigned char *output_data)
-{
-#ifdef NO_CPACF
-	UNUSED(mode);
-	UNUSED(data_length);
-	UNUSED(input_data);
-	UNUSED(iv);
-	UNUSED(des_key);
-	UNUSED(output_data);
-	return EPERM;
-#else
-#ifdef ICA_FIPS
-	if (fips)
-		return EACCES;
-#endif /* ICA_FIPS */
-
-	if (check_des_parms(mode, data_length, input_data,
-			    (unsigned char *) iv, (unsigned char *) des_key,
-			     output_data))
-		return EINVAL;
-
-	if (mode == MODE_ECB) {
-		return s390_des_ecb(DEA_ENCRYPT, data_length,
-				    input_data, (unsigned char *) des_key,
-				    output_data);
-	} else if (mode == MODE_CBC) {
-		return s390_des_cbc(DEA_ENCRYPT, data_length,
-				    input_data, (unsigned char *) iv,
-				    (unsigned char *) des_key, output_data);
-	}
-	return EINVAL;
-#endif /* NO_CPACF */
-}
-
-unsigned int ica_des_decrypt(unsigned int mode,
-			     unsigned int data_length,
-			     unsigned char *input_data,
-			     ica_des_vector_t *iv,
-			     ica_des_key_single_t *des_key,
-			     unsigned char *output_data)
-{
-#ifdef NO_CPACF
-	UNUSED(mode);
-	UNUSED(data_length);
-	UNUSED(input_data);
-	UNUSED(iv);
-	UNUSED(des_key);
-	UNUSED(output_data);
-	return EPERM;
-#else
-#ifdef ICA_FIPS
-	if (fips)
-		return EACCES;
-#endif /* ICA_FIPS */
-
-	if (check_des_parms(mode, data_length, input_data,
-			    (unsigned char *) iv, (unsigned char *) des_key,
-			     output_data))
-		return EINVAL;
-
-	if (mode == MODE_ECB) {
-		return s390_des_ecb(DEA_DECRYPT, data_length,
-				    input_data, (unsigned char *) des_key,
-				    output_data);
-	} else if (mode == MODE_CBC) {
-		return s390_des_cbc(DEA_DECRYPT, data_length,
-				    input_data, (unsigned char *) iv,
-				    (unsigned char *) des_key, output_data);
-	}
-	return EINVAL;
-#endif /* NO_CPACF */
-}
-
-unsigned int ica_3des_encrypt(unsigned int mode,
-			      unsigned int data_length,
-			      unsigned char *input_data,
-			      ica_des_vector_t *iv,
-			      ica_des_key_triple_t *des_key,
-			      unsigned char *output_data)
-{
-#ifdef NO_CPACF
-	UNUSED(mode);
-	UNUSED(data_length);
-	UNUSED(input_data);
-	UNUSED(iv);
-	UNUSED(des_key);
-	UNUSED(output_data);
-	return EPERM;
-#else
-#ifdef ICA_FIPS
-	if (fips >> 1)
-		return EACCES;
-	if (fips_check_3des_key(des_key))
-		return EINVAL;
-#endif /* ICA_FIPS */
-
-	if (check_des_parms(mode, data_length, input_data,
-			    (unsigned char *) iv, (unsigned char *) des_key,
-			     output_data))
-		return EINVAL;
-
-	if (mode == MODE_ECB) {
-		return s390_des_ecb(TDEA_192_ENCRYPT, data_length,
-				    input_data,(unsigned char *) des_key,
-				    output_data);
-	} else if (mode == MODE_CBC) {
-		return s390_des_cbc(TDEA_192_ENCRYPT, data_length,
-				    input_data, (unsigned char *) iv,
-				    (unsigned char *) des_key, output_data);
-	}
-	return EINVAL;
-#endif /* NO_CPACF */
-}
-
-unsigned int ica_3des_decrypt(unsigned int mode,
-			      unsigned int data_length,
-			      unsigned char *input_data,
-			      ica_des_vector_t *iv,
-			      ica_des_key_triple_t *des_key,
-			      unsigned char *output_data)
-{
-#ifdef NO_CPACF
-	UNUSED(mode);
-	UNUSED(data_length);
-	UNUSED(input_data);
-	UNUSED(iv);
-	UNUSED(des_key);
-	UNUSED(output_data);
-	return EPERM;
-#else
-#ifdef ICA_FIPS
-	if (fips >> 1)
-		return EACCES;
-	if (fips_check_3des_key(des_key))
-		return EINVAL;
-#endif /* ICA_FIPS */
-
-	if (check_des_parms(mode, data_length, input_data,
-			    (unsigned char *) iv, (unsigned char *) des_key,
-			     output_data))
-		return EINVAL;
-
-	if (mode == MODE_ECB) {
-		return s390_des_ecb(TDEA_192_DECRYPT, data_length,
-				    input_data, (unsigned char *) des_key,
-				    output_data);
-	} else if (mode == MODE_CBC) {
-		return s390_des_cbc(TDEA_192_DECRYPT, data_length,
-				    input_data, (unsigned char *) iv,
-				    (unsigned char *) des_key, output_data);
-	}
-	return EINVAL;
-#endif /* NO_CPACF */
-}
-
-unsigned int ica_aes_encrypt(unsigned int mode,
-			     unsigned int data_length,
-			     unsigned char *input_data,
-			     ica_aes_vector_t *iv,
-			     unsigned int key_length,
-			     unsigned char *aes_key,
-			     unsigned char *output_data)
-{
-#ifdef NO_CPACF
-	UNUSED(mode);
-	UNUSED(data_length);
-	UNUSED(input_data);
-	UNUSED(iv);
-	UNUSED(key_length);
-	UNUSED(aes_key);
-	UNUSED(output_data);
-	return EPERM;
-#else
-	unsigned int function_code;
-
-#ifdef ICA_FIPS
-	if (fips >> 1)
-		return EACCES;
-#endif /* ICA_FIPS */
-
-	/* check for obvious errors in parms */
-	if (check_aes_parms(mode, data_length, input_data,
-			    (unsigned char *) iv, key_length, aes_key,
-			    output_data))
-		return EINVAL;
-
-	function_code = aes_directed_fc(key_length, ICA_ENCRYPT);
-
-	switch (mode) {
-	case MODE_CBC:
-		return s390_aes_cbc(function_code, data_length, input_data,
-				    (unsigned char *) iv, aes_key,
-				    output_data);
-	case MODE_ECB:
-		return s390_aes_ecb(function_code, data_length, input_data,
-				    aes_key, output_data);
-	default:
-		return EINVAL;
-	}
-
-	return EINVAL;
-#endif /* NO_CPACF */
-}
-
-unsigned int ica_aes_decrypt(unsigned int mode,
-			     unsigned int data_length,
-			     unsigned char *input_data,
-			     ica_aes_vector_t *iv,
-			     unsigned int key_length,
-			     unsigned char *aes_key,
-			     unsigned char *output_data)
-{
-#ifdef NO_CPACF
-	UNUSED(mode);
-	UNUSED(data_length);
-	UNUSED(input_data);
-	UNUSED(iv);
-	UNUSED(key_length);
-	UNUSED(aes_key);
-	UNUSED(output_data);
-	return EPERM;
-#else
-	unsigned int function_code;
-
-#ifdef ICA_FIPS
-	if (fips >> 1)
-		return EACCES;
-#endif /* ICA_FIPS */
-
-	/* check for obvious errors in parms */
-	if (check_aes_parms(mode, data_length, input_data,
-			    (unsigned char *) iv, key_length, aes_key,
-			    output_data))
-		return EINVAL;
-
-	function_code = aes_directed_fc(key_length, ICA_DECRYPT);
-
-	switch (mode) {
-	case MODE_CBC:
-		return s390_aes_cbc(function_code, data_length, input_data,
-				    (unsigned char *) iv, aes_key,
-				    output_data);
-	case MODE_ECB:
-		return s390_aes_ecb(function_code, data_length, input_data,
-				    aes_key, output_data);
-	default:
-		return EINVAL;
-	}
-
-	return EINVAL;
-#endif /* NO_CPACF */
-}
-
 unsigned int ica_des_ecb(const unsigned char *in_data, unsigned char *out_data,
 			 unsigned long data_length, unsigned char *key,
 			 unsigned int direction)
@@ -3639,7 +3396,9 @@
 		       iv);
 
 	if (!rc)
-		stats_increment(ICA_STATS_AES_CMAC, ALGO_HW, ICA_DECRYPT);
+		stats_increment(ICA_STATS_AES_CMAC_128 +
+				aes_directed_fc_stats_ofs(function_code),
+				ALGO_HW, ICA_DECRYPT);
 	return rc;
 #endif /* NO_CPACF */
 }
@@ -3684,8 +3443,10 @@
 			       key_length, key, mac_length, mac, iv);
 		if (rc)
 			return rc;
-		else
-			stats_increment(ICA_STATS_AES_CMAC, ALGO_HW, direction);
+
+		stats_increment(ICA_STATS_AES_CMAC_128 +
+				aes_directed_fc_stats_ofs(function_code),
+				ALGO_HW, direction);
 	} else {
 		/* verify */
 		rc = s390_cmac(function_code, message, message_length,
@@ -3694,8 +3455,10 @@
 			return rc;
 		if (CRYPTO_memcmp(tmp_mac, mac, mac_length))
 			return EFAULT;
-		else
-			stats_increment(ICA_STATS_AES_CMAC, ALGO_HW, direction);
+
+		stats_increment(ICA_STATS_AES_CMAC_128 +
+				aes_directed_fc_stats_ofs(function_code),
+				ALGO_HW, direction);
 	}
 
 	return 0;
@@ -4483,14 +4246,18 @@
 #endif /* NO_CPACF */
 }
 
-#ifdef ICA_FIPS
-
 int
 ica_fips_status(void)
 {
+#ifdef ICA_FIPS
 	return fips;
+#else
+	return 0;
+#endif
 }
 
+#ifdef ICA_FIPS
+
 void
 ica_fips_powerup_tests(void)
 {
diff -Nru libica-3.9.0/src/icainfo.c libica-4.0.0/src/icainfo.c
--- libica-3.9.0/src/icainfo.c	2021-10-13 16:00:38.000000000 +0200
+++ libica-4.0.0/src/icainfo.c	2021-12-06 12:01:54.000000000 +0100
@@ -333,6 +333,8 @@
 	{"X25519 Derive", X25519_DERIVE},
 	{"X448 Keygen", X448_KEYGEN},
 	{"X448 Derive", X448_DERIVE},
+	{"RSA Keygen ME", RSA_KEY_GEN_ME},
+	{"RSA Keygen CRT", RSA_KEY_GEN_CRT},
 	{"RSA ME", RSA_ME},
 	{"RSA CRT", RSA_CRT},
 	{"DES ECB", DES_ECB},
@@ -462,7 +464,7 @@
 #endif /* ICA_FIPS */
 
 #ifdef NO_SW_FALLBACKS
-	printf("Software fallbacks are disabled in libica-cex.\n");
+	printf("Software fallbacks are disabled.\n");
 #endif
 #ifdef NO_CPACF
 	printf("CPACF support (including fallbacks) is disabled in libica-cex.\n");
diff -Nru libica-3.9.0/src/icastats.c libica-4.0.0/src/icastats.c
--- libica-3.9.0/src/icastats.c	2021-10-13 16:00:38.000000000 +0200
+++ libica-4.0.0/src/icastats.c	2021-12-06 12:01:54.000000000 +0100
@@ -21,10 +21,13 @@
 #include <getopt.h>
 #include <pwd.h>
 #include <libgen.h>
+#include <errno.h>
+#include <time.h>
+#include <sys/utsname.h>
 #include "icastats.h"
 
 #define CMD_NAME "icastats"
-#define COPYRIGHT "Copyright IBM Corp. 2009-2019"
+#define COPYRIGHT "Copyright IBM Corp. 2009-2021"
 
 void print_version(void)
 {
@@ -43,13 +46,15 @@
 	       " -d, --delete        delete your own statistics.\n"
 	       " -D, --delete-all    delete the statistics from all users. (root user only)\n"
 	       " -U, --user <userid> show the statistics from one user. (root user only)\n"
-	       " -S, --summary       show the accumulated statistics from alle users. (root user only)\n"
+	       " -S, --summary       show the accumulated statistics from all users. (root user only)\n"
 	       " -A, --all	     show the statistic tables from all users. (root user only)\n"
+	       " -k, --key-sizes     show statistics per key size.\n"
+	       " -j, --json          output the statistics in JSON format.\n"
 	       " -v, --version       output version information\n"
 	       " -h, --help          display help information\n");
 }
 
-#define getopt_string "rRdDU:SAvh"
+#define getopt_string "rRdDU:SAkjvh"
 static struct option getopt_long_options[] = {
 	{"reset", 0, 0, 'r'},
 	{"reset-all", 0, 0, 'R'},
@@ -58,6 +63,8 @@
 	{"user", required_argument, 0, 'U'},
 	{"summary", 0, 0, 'S'},
 	{"all", 0, 0, 'A'},
+	{"key-sizes", 0, 0, 'k'},
+	{"json", 0, 0, 'j'},
 	{"version", 0, 0, 'v'},
 	{"help", 0, 0, 'h'},
 	{0, 0, 0, 0}
@@ -70,22 +77,25 @@
 
 
 #define CELL_SIZE 12
-void print_stats(stats_entry_t *stats)
+void print_stats(stats_entry_t *stats, int key_sizes)
 {
 	printf(" function       |             hardware         |              software\n");
 	printf("----------------+------------------------------+-----------------------------\n");
 	printf("                |        ENC    CRYPT     DEC  |        ENC     CRYPT    DEC \n");
 	printf("----------------+------------------------------+-----------------------------\n");
 	unsigned int i;
-	for (i = 0; i < ICA_NUM_STATS; ++i){
-		if(i<=ICA_STATS_RSA_CRT){
+	for (i = 0; i < ICA_NUM_STATS; ++i) {
+		if (!key_sizes && strncmp(STATS_DESC[i], "- ", 2) == 0)
+			continue;
+
+		if(i <= ICA_STATS_RSA_CRT_4096) {
 			printf(" %14s |        %*lu          |         %*lu\n",
 			       STATS_DESC[i],
 			       CELL_SIZE,
 			       stats[i].enc.hw,
 			       CELL_SIZE,
 			       stats[i].enc.sw);
-		} else{
+		} else {
 			printf(" %14s |%*lu     %*lu |%*lu    %*lu\n",
 			       STATS_DESC[i],
 			       CELL_SIZE,
@@ -101,8 +111,96 @@
 	}
 }
 
+static int first_usr;
+
+void print_json_header()
+{
+	char timestamp[200];
+	struct utsname un;
+	struct tm *tm;
+	time_t t;
+
+	time(&t);
+	tm = gmtime(&t);
+	/* ISO 8601 format: e.g. 2021-11-17T08:01:23Z (always UTC) */
+	strftime(timestamp, sizeof(timestamp), "%FT%TZ", tm);
+
+	if (uname(&un) != 0) {
+		fprintf(stderr, "Failed to obtain system information, uname: %s",
+		       strerror(errno));
+		return;
+	}
+
+	printf("{\n\t\"host\": {\n");
+	printf("\t\t\"nodename\": \"%s\",\n", un.nodename);
+	printf("\t\t\"sysname\": \"%s\",\n", un.sysname);
+	printf("\t\t\"release\": \"%s\",\n", un.release);
+	printf("\t\t\"machine\": \"%s\",\n", un.machine);
+	printf("\t\t\"date\": \"%s\"\n", timestamp);
+	printf("\t},\n\t\"users\": [");
+
+	first_usr = 1;
+}
+
+void print_stats_json(stats_entry_t *stats, const char *usr)
+{
+	unsigned int i;
+	const char *last_func = NULL;
+
+	if (!first_usr)
+		printf(",");
+	printf("\n\t\t{\n\t\t\t\"user\": \"%s\",\n", usr);
+	printf("\t\t\t\"functions\": [");
+
+	for (i = 0; i < ICA_NUM_STATS; ++i) {
+		if (i < ICA_NUM_STATS - 1 &&
+		    strncmp(STATS_DESC[i + 1], "- ", 2) == 0 &&
+		    strncmp(STATS_DESC[i], "- ", 2) != 0) {
+			last_func = STATS_DESC[i];
+			continue;
+		}
+
+		if (i != 0)
+			printf(",");
+		printf("\n\t\t\t\t{\n");
+
+		if (strncmp(STATS_DESC[i], "- ", 2) == 0 && last_func != NULL) {
+			printf("\t\t\t\t\t\"function\": \"%s %s\",\n",
+			       last_func, STATS_DESC[i]);
+		} else {
+			printf("\t\t\t\t\t\"function\": \"%s\",\n",
+			       STATS_DESC[i]);
+			last_func = NULL;
+		}
+
+		if (i <= ICA_STATS_RSA_CRT_4096) {
+			printf("\t\t\t\t\t\"hw-crypt\": %lu,\n",
+			       stats[i].enc.hw);
+			printf("\t\t\t\t\t\"sw-crypt\": %lu\n",
+			       stats[i].enc.sw);
+		} else {
+			printf("\t\t\t\t\t\"hw-enc\": %lu,\n",
+			       stats[i].enc.hw);
+			printf("\t\t\t\t\t\"sw-enc\": %lu,\n",
+			       stats[i].enc.sw);
+			printf("\t\t\t\t\t\"hw-dec\": %lu,\n",
+			       stats[i].dec.hw);
+			printf("\t\t\t\t\t\"sw-dec\": %lu\n",
+			       stats[i].dec.sw);
+		}
+
+		printf("\t\t\t\t}");
+	}
 
+	printf("\n\t\t\t]\n\t\t}");
 
+	first_usr = 0;
+}
+
+void print_json_footer()
+{
+	printf("\n\t]\n}\n");
+}
 
 int main(int argc, char *argv[])
 {
@@ -113,6 +211,8 @@
 	int sum = 0;
 	int user = -1;
 	int all = 0;
+	int key_sizes = 0;
+	int json = 0;
 	struct passwd *pswd;
 
 	while ((rc = getopt_long(argc, argv, getopt_string,
@@ -155,6 +255,12 @@
 		case 'A':
 			all = 1;
 			break;
+		case 'k':
+			key_sizes = 1;
+			break;
+		case 'j':
+			json = 1;
+			break;
 		case 'v':
 			print_version();
 			exit(0);
@@ -191,16 +297,24 @@
 	if(all){
 		char *usr;
 		stats_entry_t *entries;
+		if (json)
+			print_json_header();
 		while((usr = get_next_usr()) != NULL){
 			if((entries = malloc(sizeof(stats_entry_t)*ICA_NUM_STATS)) == NULL){
 				perror("malloc: ");
 				return EXIT_FAILURE;
 			}
-			get_stats_data(entries);;
-			printf("user: %s\n", usr);
-			print_stats(entries);
+			get_stats_data(entries);
+			if (json) {
+				print_stats_json(entries, usr);
+			} else {
+				printf("user: %s\n", usr);
+				print_stats(entries, key_sizes);
+			}
 			free(entries);
 		}
+		if (json)
+			print_json_footer();
 		return EXIT_SUCCESS;
 	}
 
@@ -215,10 +329,14 @@
 			perror("get_stats_sum: ");
 			return EXIT_FAILURE;
 		}
-		print_stats(entries);
+		if (json) {
+			print_json_header();
+			print_stats_json(entries, "all users");
+			print_json_footer();
+		} else {
+			print_stats(entries, key_sizes);
+		}
 		return EXIT_SUCCESS;
-
-
 	}
 
 	if(reset == 2){
@@ -243,7 +361,18 @@
 			return EXIT_FAILURE;
 		}
 		get_stats_data(stats);
-		print_stats(stats);
+		if (json) {
+			pswd = getpwuid(user == -1 ? geteuid() : (uid_t)user);
+			if (pswd == NULL) {
+				fprintf(stderr, "Failed to get user name");
+				return EXIT_FAILURE;
+			}
+			print_json_header();
+			print_stats_json(stats, pswd->pw_name);
+			print_json_footer();
+		} else {
+			print_stats(stats, key_sizes);
+		}
 
 	}
 	return EXIT_SUCCESS;
diff -Nru libica-3.9.0/src/icastats_shared.c libica-4.0.0/src/icastats_shared.c
--- libica-3.9.0/src/icastats_shared.c	2021-10-13 16:00:38.000000000 +0200
+++ libica-4.0.0/src/icastats_shared.c	2021-12-06 12:01:54.000000000 +0100
@@ -33,22 +33,6 @@
 static stats_entry_t *stats = NULL;
 volatile int stats_shm_handle = NOT_INITIALIZED;
 
-
-static inline void atomic_add(uint64_t *x, uint64_t i)
-{
-    uint64_t old;
-    uint64_t new;
-    asm volatile ("   lg      %0,%2\n"
-                  "0: lgr     %1,%0\n"
-                  "   agr     %1,%3\n"
-                  "   csg     %0,%1,%2\n"
-                  "   jl      0b"
-                 :"=&d" (old), "=&d"(new), "=Q"(*x)
-                 :"d"(i), "Q"(*x)
-                 :"cc", "memory");
-}
-
-
 /* open shared memory segment
  * Arguments:
  * @user: if user is -1 stats_mmap will open the shared memory segent of the same
@@ -63,24 +47,36 @@
 int stats_mmap(int user)
 {
 	char shm_id[NAME_LENGHT];
+	struct stat stat_buf;
 
 	if (stats == NULL) {
 		sprintf(shm_id, "icastats_%d",
 			user == -1 ? geteuid() : (uid_t)user);
 
-		stats_shm_handle = shm_open(shm_id, O_CREAT | O_RDWR,
+		stats_shm_handle = shm_open(shm_id, O_RDWR,  S_IRUSR | S_IWUSR);
+		if (stats_shm_handle == NOT_INITIALIZED)
+			stats_shm_handle = shm_open(shm_id, O_CREAT | O_RDWR,
 						    S_IRUSR | S_IWUSR);
 
 		if (stats_shm_handle == NOT_INITIALIZED)
 			return -1;
 
 		if (user > 0 && geteuid() == 0) {
-			if (fchown(stats_shm_handle, user, user) == -1)
+			if (fchown(stats_shm_handle, user, user) == -1) {
+				close(stats_shm_handle);
 				return -1;
+			}
+		}
+
+		if (fstat(stats_shm_handle, &stat_buf)) {
+			close(stats_shm_handle);
+			return -1;
 		}
 
-		if (ftruncate(stats_shm_handle, STATS_SHM_SIZE) == -1)
+		if (ftruncate(stats_shm_handle, STATS_SHM_SIZE) == -1) {
+			close(stats_shm_handle);
 			return -1;
+		}
 
 		stats = (stats_entry_t *) mmap(NULL, STATS_SHM_SIZE, PROT_READ |
 						 PROT_WRITE, MAP_SHARED,
@@ -90,6 +86,9 @@
 			stats = NULL;
 			return -1;
 		}
+
+		if (stat_buf.st_size != STATS_SHM_SIZE)
+			memset(stats, 0, STATS_SHM_SIZE);
 	}
 	return 0;
 }
@@ -142,18 +141,87 @@
 			return stats[field].dec.sw;
 }
 
+static uint64_t calc_summary(stats_fields_t start, unsigned int num,
+		             int hardware, int direction)
+{
+	unsigned int i;
+	uint64_t sum = 0;
+
+	for (i = 0; i < num; i++)
+		sum += stats_query(start + i, hardware, direction);
+
+	return sum;
+}
+
 /* Returns the statistic data in a stats_entry_t array
  * @entries - Needs to be a array of size ICA_NUM_STATS.
  */
-
 void get_stats_data(stats_entry_t *entries)
 {
 	unsigned int i;
-	for(i = 0;i<ICA_NUM_STATS; i++){
-		entries[i].enc.hw = stats_query(i, ALGO_HW, ENCRYPT);
-		entries[i].enc.sw = stats_query(i, ALGO_SW, ENCRYPT);
-		entries[i].dec.hw = stats_query(i, ALGO_HW, DECRYPT);
-		entries[i].dec.sw = stats_query(i, ALGO_SW, DECRYPT);
+	for(i = 0; i < ICA_NUM_STATS; i++) {
+		switch (i) {
+		case ICA_STATS_AES_ECB:
+		case ICA_STATS_AES_CBC:
+		case ICA_STATS_AES_OFB:
+		case ICA_STATS_AES_CFB:
+		case ICA_STATS_AES_CTR:
+		case ICA_STATS_AES_CMAC:
+		case ICA_STATS_AES_GCM:
+			entries[i].enc.hw = calc_summary(i + 1, 3,
+					                 ALGO_HW, ENCRYPT);
+			entries[i].enc.sw = calc_summary(i + 1, 3,
+					                 ALGO_SW, ENCRYPT);
+			entries[i].dec.hw = calc_summary(i + 1, 3,
+					                 ALGO_HW, DECRYPT);
+			entries[i].dec.sw = calc_summary(i + 1, 3,
+					                 ALGO_SW, DECRYPT);
+			break;
+
+		case ICA_STATS_AES_XTS:
+			entries[i].enc.hw = calc_summary(i + 1, 2,
+					                 ALGO_HW, ENCRYPT);
+			entries[i].enc.sw = calc_summary(i + 1, 2,
+					                 ALGO_SW, ENCRYPT);
+			entries[i].dec.hw = calc_summary(i + 1, 2,
+					                 ALGO_HW, DECRYPT);
+			entries[i].dec.sw = calc_summary(i + 1, 2,
+					                 ALGO_SW, DECRYPT);
+			break;
+
+		case ICA_STATS_RSA_ME:
+		case ICA_STATS_RSA_CRT:
+			entries[i].enc.hw = calc_summary(i + 1, 4,
+					                 ALGO_HW, ENCRYPT);
+			entries[i].enc.sw = calc_summary(i + 1, 4,
+					                 ALGO_SW, ENCRYPT);
+			entries[i].dec.hw = calc_summary(i + 1, 4,
+					                 ALGO_HW, DECRYPT);
+			entries[i].dec.sw = calc_summary(i + 1, 4,
+					                 ALGO_SW, DECRYPT);
+			break;
+
+		case ICA_STATS_ECDH:
+		case ICA_STATS_ECDSA_SIGN:
+		case ICA_STATS_ECDSA_VERIFY:
+		case ICA_STATS_ECKGEN:
+			entries[i].enc.hw = calc_summary(i + 1, 8,
+					                 ALGO_HW, ENCRYPT);
+			entries[i].enc.sw = calc_summary(i + 1, 8,
+					                 ALGO_SW, ENCRYPT);
+			entries[i].dec.hw = calc_summary(i + 1, 8,
+					                 ALGO_HW, DECRYPT);
+			entries[i].dec.sw = calc_summary(i + 1, 8,
+					                 ALGO_SW, DECRYPT);
+			break;
+
+		default:
+			entries[i].enc.hw = stats_query(i, ALGO_HW, ENCRYPT);
+			entries[i].enc.sw = stats_query(i, ALGO_SW, ENCRYPT);
+			entries[i].dec.hw = stats_query(i, ALGO_HW, DECRYPT);
+			entries[i].dec.sw = stats_query(i, ALGO_SW, DECRYPT);
+			break;
+		}
 	}
 }
 
@@ -277,14 +345,14 @@
 
 	if(direction == ENCRYPT)
 		if (hardware == ALGO_HW)
-			atomic_add(&stats[field].enc.hw, 1);
+			__sync_add_and_fetch(&stats[field].enc.hw, 1);
 		else
-			atomic_add(&stats[field].enc.sw, 1);
+			__sync_add_and_fetch(&stats[field].enc.sw, 1);
 	else
 		if (hardware == ALGO_HW)
-			atomic_add(&stats[field].dec.hw, 1);
+			__sync_add_and_fetch(&stats[field].dec.hw, 1);
 		else
-			atomic_add(&stats[field].dec.sw, 1);
+			__sync_add_and_fetch(&stats[field].dec.sw, 1);
 }
 #endif
 
